	//
	//  randomLinkPlugIn.m
	//  randomLink
	//
	//  Created by inimArt on 23/06/11.
	//

#import <OpenGL/CGLMacro.h>

#import "structureTestPlugin.h"

#define	kQCPlugIn_Name				@"structureTest"
#define	kQCPlugIn_Description		@"structureTest"

@implementation structureTestPlugIn

@dynamic input_numVertices, output_struct;


+ (NSDictionary*) attributes
{
	return [NSDictionary dictionaryWithObjectsAndKeys:kQCPlugIn_Name, QCPlugInAttributeNameKey, kQCPlugIn_Description, QCPlugInAttributeDescriptionKey, nil];
}

+ (NSDictionary*) attributesForPropertyPortWithKey:(NSString*)key
{
    if([key isEqualToString:@"input_numVertices"])		return [NSDictionary dictionaryWithObjectsAndKeys:@"numVertices", QCPortAttributeNameKey, nil];
    if([key isEqualToString:@"input_col"])				return [NSDictionary dictionaryWithObjectsAndKeys:@"color", QCPortAttributeNameKey, nil];
	
	return nil;
}

+ (QCPlugInExecutionMode) executionMode
{
	return kQCPlugInExecutionModeProcessor;
}

+ (QCPlugInTimeMode) timeMode
{
	return kQCPlugInTimeModeNone;
}

- (id) init
{
	if(self = [super init]) {
	}
	
	return self;
}

- (void) finalize
{
	[super finalize];
}

- (void) dealloc
{
	[super dealloc];
}

+ (NSArray*) plugInKeys
{
	return nil;
}

- (id) serializedValueForKey:(NSString*)key;
{
	return [super serializedValueForKey:key];
}

- (void) setSerializedValue:(id)serializedValue forKey:(NSString*)key
{
	[super setSerializedValue:serializedValue forKey:key];
}

- (QCPlugInViewController*) createViewController
{
	return [[QCPlugInViewController alloc] initWithPlugIn:self viewNibName:@"Settings"];
}

/*
 Create a random number between smallNumber and bigNumber
 */
- (float)randomFloatBetween:(float)smallNumber and:(float)bigNumber {
	float diff = bigNumber - smallNumber;
	float result = (((float) (random() % ((unsigned)RAND_MAX + 1)) / RAND_MAX) * diff) + smallNumber;
	return result;
}

@end

@implementation structureTestPlugIn (Execution)

- (BOOL) startExecution:(id<QCPlugInContext>)context
{
		//Init Vertices positions
	for(int x=0;x<VSIZE;x++){
		v[x][0] = [self randomFloatBetween:-XRANGE and:XRANGE];
		v[x][1] = [self randomFloatBetween:-YRANGE and:YRANGE];
		v[x][2] = [self randomFloatBetween:-ZRANGE and:ZRANGE];
	}
	
	currVertex = [[NSMutableArray alloc] init];
	outputVertices = [[NSMutableArray alloc] init];
	
	return YES;
}

- (void) enableExecution:(id<QCPlugInContext>)context
{
}


- (BOOL) execute:(id<QCPlugInContext>)context atTime:(NSTimeInterval)time withArguments:(NSDictionary*)arguments
{
		//How many vertices does our output structure contain? 
	numV = self.input_numVertices;
	if(numV > VSIZE) numV = VSIZE;
	[outputVertices removeAllObjects];
	for(int x=0;x<numV;x++){
		[currVertex removeAllObjects];
		[currVertex addObject:[NSNumber numberWithFloat:v[x][0]]];
		[currVertex addObject:[NSNumber numberWithFloat:v[x][1]]];
		[currVertex addObject:[NSNumber numberWithFloat:v[x][2]]];
		[currVertex addObject:[NSNumber numberWithFloat:1.0]];
		[outputVertices addObject:[NSArray arrayWithArray:currVertex]];
	}
	
		//create output structure
	self.output_struct = [NSArray arrayWithArray:outputVertices];
	
	return YES;
}

- (void) disableExecution:(id<QCPlugInContext>)context
{
}

- (void) stopExecution:(id<QCPlugInContext>)context
{
	[currVertex removeAllObjects];
	[outputVertices removeAllObjects];
	[currVertex release];
	[outputVertices release];
}

@end
